goog.provide 'server.main'

goog.require 'app.DocumentCreator'
goog.require 'server.DiContainer'
goog.require 'server.document.Storage'
goog.require 'server.formatter.Storage'

###*
  @param {Object} config
###
server.main = (config) ->

  container = new server.DiContainer

  # Note how CommonJS modules are injected. Requiring from different place
  # than composite root is an anti-pattern leading toward hard to test code.
  container.configure {
    resolve: server.App
    with: {
      isDev: config['env']['development']
      port: config['server']['port']
      express: require 'express'
    }
  }, {
    resolve: app.document.Store
    with: {
      storage: new server.document.Storage()
    }
  }, {
    resolve: app.formatter.Store
    with: {
      storage: new server.formatter.Storage()
    }
  }
  container.resolveServerApp()

goog.exportSymbol 'server.main', server.main
