goog.provide 'App'
goog.require 'este.Routes'

class App
  ###*
    @param {este.Router} router
    @param {app.Routes} routes
    @param {app.EditorStore} editorStore
    @param {app.DocumentStore} store
    @param {app.AppComponent} appComponent
    @param {Element} element
    @constructor
  ###
  # reactApp, listApp, docApp, d
  constructor: (router, routes, editorStore, store, appComponent, element) ->
    syncUI = ->
      # when on /, passed undefined prop activeModule, so the default one
      # is applied
      activeModule = routes.active.path
      appState = editorStore.appState
      appWithData = appComponent.reactClass({activeModule, appState})
      React.renderComponent appWithData, element

    routes.addToEste router, (route, params) ->
      routes.setActive route, params
      syncUI()

    router.start()
    editorStore.listen app.EditorStore.EventType.AppStateChange, syncUI

  ###*
    @enum {string}
  ###
  @Modules = {
    Editor: 'edit'
    Viewer: 'view'
    Formatter: 'format'
  }

  @AllModules = [
    @Modules.Editor, @Modules.Viewer, @Modules.Formatter
  ]