goog.provide 'app.document.Block'


goog.require 'app.BlockType'
goog.require 'goog.string'
goog.require 'goog.object'
goog.require 'app.object'

###
  General model for blocks.
  2 subclasses:
  TextBlock - has its content
  StructureBlock - used for structuring document

  Keep it simple.

  Only
###
class app.document.Block

  ###*
    @param {Object=} attributes
    @param {Function=} randomStringGenerator
    @param {Function=} overrideIfTruthy
    @constructor
  ###
  constructor: (
      attributes = {}
      randomStringGenerator = goog.string.getRandomString
      overrideIfTruthy = app.object.overrideIfTruthy
    ) ->

#    overrideIfTruthy this, attributes

    @_id = attributes._id || randomStringGenerator()
    @title = attributes.title if attributes.title
    # must test for presence, because type is set in descendants
    @type = attributes.type if attributes.type
    @comment = attributes.comment if attributes.comment
    @authorNote = attributes.authorNote if attributes.authorNote

    throw Error 'Block should have valid type by now.' unless @type

  ###*
    @type {string}
    @expose
  ###
  _id: ''

  ###*
    @type {string}
    @expose
  ###
  title: ''

  ###*
    @type {string}
    @expose
  ###
  type: ''

  ###*
    @type {string}
    @expose
  ###
  comment: ''

  ###*
    @type {string}
    @expose
  ###
  authorNote: ''

