goog.provide 'app.document.Document'

goog.require 'app.document.Block'
goog.require 'app.document.StructuredBlock'
goog.require 'app.BlockType'
goog.require 'app.formatter.DocumentSettings'

class app.document.Document extends app.document.StructuredBlock

  ###*
    @constructor
    @extends {app.document.StructuredBlock}
    @final
  ###
  constructor: (attributes={}) ->
    @type = app.BlockType.Document
    super(attributes)
    @author ||= attributes.author if attributes.author
    @_rev ||= attributes._rev if attributes._rev
    @formatSettings = new app.formatter.DocumentSettings(attributes.formatSettings)

  ###*
    @type {string} document author`s id
    @expose
  ###
  author: ''

  ###*
    Revision string for PouchDB.
    @type {string}
    @expose
  ###
  _rev: ''

  ###*
    @type {app.formatter.DocumentSettings}
    @expose
  ###
  formatSettings: null
