goog.provide 'app.document.Storage'

class app.document.Storage

  @DB_NAME: 'docs'

  ###*
    @type {PouchDB}
    @private
  ###
  db: null

  ###* @type {boolean} - state, app must work on latest _rev ###
  canPutNewVersion: true

  ###*
    @constructor
    @param {PouchDB} db
  ###
  constructor: (@db) ->

  ###*
    @param {app.document.Document} doc
    @return {Promise}
  ###
  deleteDocument: (doc) ->
    return @db.remove doc

  ###*
    @param {PouchDBAllDocsResult} result
    @return {Promise | Array.<Object>}
  ###
  _filterDocs: (result) ->
    return result.rows.map (docObject) -> {title: docObject.doc.title, _id: docObject.doc._id, _rev: docObject.doc._rev
      }

  _filterDocProps: (doc) ->


  ###*
    @return {Promise} - app.document.Document
  ###
  loadDocument: (id) ->
    getResult = @db.get id
    return getResult

  ###*
    @return {Promise} - Object with Array.<app.document.Document>
  ###
  loadAllDocs: ->
    allQueryRes = @db.allDocs({include_docs: true})
    return allQueryRes.then(@_filterDocs)

  reset: ->

  ###*
    Returns null if could not save.
    @param {app.document.Document} doc
    @return {Promise}
  ###
  saveDocument: (doc) ->
    if @canPutNewVersion
      console.log 'putting new doc: ', doc if app.lamebug
      @canPutNewVersion = false
      return @db.put(doc)
    else
      return null



  ###*
    Call when store is in sync with latest revision.
  ###
  updatedRev: ->
    @canPutNewVersion = true