goog.require 'tests.Factory'
goog.require 'app.BlockType'

createBlock = tests.Factory.Block.create

isList = (block) ->
  assert.equal block.type, app.BlockType.List

isParagraph = (block) ->
  assert.equal block.type, app.BlockType.Paragraph

suite 'app.editor.TransformType', ->
  setup ->
    @transform = new app.editor.TransformType

  test 'paragraph => list', ->
    block = createBlock({text: 'Colosseum is...\nCircus Maximus'})
    list = @transform._paragraph_to_list(block)
    assert.deepEqual list.items, ['Colosseum is...', 'Circus Maximus']
    isList list

  test '(empty) paragraph => list', ->
    paragraph = createBlock({text: ''})
    list = @transform._paragraph_to_list(paragraph)
    assert.deepEqual list.items, ['']
    isList list

  test 'list => paragraph', ->
    list = createBlock({items: ['Pompey\nOctavia\nNero'], type: app.BlockType.List})
    p = @transform._list_to_paragraph(list)
    assert.equal p.text, ['Pompey\nOctavia\nNero']
    isParagraph p

  test '(empty) list => paragraph', ->
    list = createBlock({items: [], type: app.BlockType.List})
    p = @transform._list_to_paragraph(list)
    assert.equal p.text, ['']
    isParagraph p
