goog.provide 'app.editor.ReferencePane'
###*
  PROPS
  reference = actual object or empty object literal
  marked {string|undefined} - marked text

  Links are ordered in the owner - block.
###
do ->
  {span, button, div, p, input, a, li, ul, ol} = React.DOM

  app.editor.ReferencePane.reactClass = React.createClass(
    getInitialState: ->
      return {
        editedLinkIdx: 0
      }

    getDefaultProps: ->
      return {
        links: []
      }

    changeEditedRef: (idx) ->
      @setState editedLinkIdx: idx

    ###*
      @param {Object} active
      @param {{reference: Object, marked: string}} link
      @param {number} idx - index of reference in array
    ###
    makeReference: (active, link, idx) ->
      attrs = {onMouseOver: @changeEditedRef.bind(@, idx)}
      if active == link
        attrs['className'] = 'ref-active'

      reference = link.reference

      return li(
        attrs
        div(
          {className: 'marked'}
          if link.marked
            div(
              {}
              span({}, link.marked)
              button({title: 'unlink', href: '#'}, li({}, 'x'))
            )
          else
            button(
              {}
              'mark text'
            )
        )
        div(
          {}
          reference.title || button(
            {}
            'add ref'
          )
        )
        button(
          {title: 'delete reference', className: 'ref-delete'}
          'x'
        )
      )

    render: ->
      addRef = ul(
        {}
        div(
          {}
          span({}, 'link reference')
          input({})
          button({href: '#'}, li({}, 'add'))
        )
      )
      active = @props.links[@state.editedLinkIdx]
      div(
        {className: 'pane note'}
        ol(
          {className: 'refs'}
          @props.links.map @makeReference.bind(null, active)
        )
        addRef
      )
  )
