goog.provide 'app.formatter.DocumentSettings'

goog.require 'app.formatter.Document'

###
  See
  http://www.ampsoft.net/webdesign-l/WindowsMacFonts.html
  http://www.pixy.cz/pixylophone/2003_06_archiv.html -- Česká písma: finální řešení
###
class app.formatter.DocumentSettings

  ###*
    @enum {string}
  ###
  @FontFamily = {
    Arial: 'Arial'
    Tahoma: 'Tahoma'
    Trebuchet: 'Trebuchet'
    Verdana: 'Verdana'
  }
  @FontFamilyName = {
    Arial: 'Arial / Helvetica'
    Tahoma: 'Tahoma / Lucida'
    Trebuchet: 'Trebuchet / Geneva'
    Verdana: 'Verdana / Lucida'
  }

  @FontFamilyValue = {
    Arial: 'Arial, Helvetica, sans-serif'
    Tahoma: 'Tahoma, "Lucida Grande CE", lucida, sans-serif'
    Trebuchet: 'Trebuchet, "Trebuchet MS", "Geneva CE", lucida, sans-serif'
    Verdana: 'Verdana, "Geneva CE", lucida, sans-serif'
  }

  ###*
    @param {Object=} initial
    @constructor
  ###
  constructor: (initial={}) ->
    @fontSize = initial.fontSize if initial.fontSize
    @fontFamily = initial.fontFamily if initial.fontFamily

  ###*
    Base font size in [pt].
    @type {number}
    @expose
  ###
  fontSize: 11

  ###*
    Font family.
    @type {app.formatter.DocumentSettings.FontFamily}
    @expose
  ###
  fontFamily: app.formatter.DocumentSettings.FontFamily.Arial

