goog.provide 'app.formatter.FontCalc'

goog.require 'app.object'

###
###
class app.formatter.FontCalc

  ###*
    @type {number}
  ###
  lowestHeader: 6


  difference: 1.2


  baseSize: 12

  ###*
    @constructor
  ###
  constructor: ->

  setDifference: (diff) ->
    if diff >= 1.2 && diff <= 2
      @difference = diff
    else
      console.error('bad difference, not in range of 1.2 to 2') if app.debug

  setBaseSize: (size) ->
    if size >= app.formatter.Document.MinFontSize && size <= app.formatter.Document.MaxFontSize
      @baseSize = size
    else
      console.error("bad base size given `#{size}`, not in range of min and max size") if app.debug

  setLowestHeader: (size) ->
    if size >= 1 && size <= 6
      @lowestHeader = size
    else
      console.error('bad input in setLowestHeader') if app.debug

  ###*
    @param {{
      lowestHeader: (number|undefined),
      baseSize: (number|undefined),
      difference: (number|undefined)
    }} values
  ###
  setAllValues: (values) ->
    app.object.overrideIfTruthy(this, values)

  ###*
    @param {number} level
  ###
  headerSize: (level) ->
    if (level == @lowestHeader)
      return @baseSize
    else
      sizeMultiplier = Math.pow(@difference, @lowestHeader - level)
      size = @baseSize * sizeMultiplier
      return size.toFixed(2)

