goog.provide 'app.references.ShowRefs'
goog.provide 'app.references.Citations'
goog.provide 'app.references.Terms'

goog.require 'app.document.Reference'

do ->
  {label, button, textarea, div, h2, input, ul, li} = React.DOM

  app.references.ReferenceMixin = {
    renderTitle: (ref) ->
      div(
        {className: 'form-group'}
        label(
          {}
          'title'
          input(
            {
              className: 'form-control ref-title'
              id: ref._id
              defaultValue: ref.title
              onBlur: @props.onTitleChange.bind(null, ref)
            }
          )
        )
      )

    refButton: ->
      button(
        {onClick: @props.onAddRef}
        'add new ref'
      )

    render: ->
      div(
        {}
        h2(
          {}
          @props.referenceTypeTitle
        )
        ul(
          {className: 'reference-list'}
          @props.refs.map @makeRef
        )
        @refButton()
      )
  }

  app.references.Citations.reactClass = React.createClass(
    getDefaultProps: -> {referenceTypeTitle: 'Citations'}

    mixins: [app.references.ReferenceMixin]

    onCitationEdit: (ref, event) ->
      citation = event.target.value
      @props.onRefChange ref, {citation} unless ref.citation == citation

    ###* @param {app.document.Reference} ref ###
    makeRef: (ref) ->
      li(
        {key: ref._id}
        @renderTitle(ref)
        label({}, 'citation')
        textarea(
          {
            placeholder: 'new citation'
            defaultValue: ref.citation
            className: 'form-control'
            onBlur: @onCitationEdit.bind(@, ref)
            rows: 3
          }
        )
      )
  )

  app.references.Terms.reactClass = React.createClass(
    getDefaultProps: -> {referenceTypeTitle: 'Terms'}
    mixins: [app.references.ReferenceMixin]

    onDescriptionChange: (ref, event) ->
      description = event.target.value
      @props.onRefChange ref, {description}

    ###* @param {app.document.Reference} ref ###
    makeRef: (ref) ->
      li(
        {key: ref._id}
        @renderTitle(ref)

        label({}, 'description')
        textarea(
          {
            placeholder: 'new description'
            value: ref.description
            className: 'form-control'
            onChange: @onDescriptionChange.bind(@, ref)
          }
        )
      )
  )